# -*- coding: utf-8 -*-
# Generated by Kaname on 2018-13-11 21:35
from __future__ import unicode_literals

from django.db import migrations
from django.conf import settings
from django.utils.crypto import get_random_string
import os


def path_info_recv(instance, filename):
    filename, file_extension = os.path.splitext(filename)
    random_str = get_random_string(length=12)
    info = instance.reference.info_sup_file
    return "protected/billetterie/event_{0}/billet_{1}/{2}_{3}{4}".format(
        info.ticket.event.pk, instance.registration.id, info.file_name, random_str, file_extension
    )


def migrate_template(apps, schema_editor):
    Info_Sup_Recv_File = apps.get_model("guichet", "Info_Sup_Recv_File")
    db_alias = schema_editor.connection.alias
    for info_file in Info_Sup_Recv_File.objects.using(db_alias).all():
        if not info_file.upload_file:
            continue

        initial_path = os.path.join(settings.MEDIA_ROOT, info_file.upload_file.path)
        new_path = path_info_recv(info_file, initial_path)
        info_file.upload_file.name = new_path
        path = os.path.join(settings.MEDIA_ROOT, new_path)
        if not os.path.exists(os.path.dirname(path)):
            os.makedirs(os.path.dirname(path))
        os.rename(initial_path, path)
        info_file.save()


class Migration(migrations.Migration):

    dependencies = [
        ("guichet", "0079_squashed_0001_0078"),
    ]

    operations = [
        migrations.RunPython(migrate_template),
    ]
